Index: doc/images/strongly_connected_components.eps
===================================================================
--- doc/images/strongly_connected_components.eps	(revision 634)
+++ doc/images/strongly_connected_components.eps	(revision 1213)
@@ -1,5 +1,5 @@
 %!PS-Adobe-2.0 EPSF-2.0
 %%Creator: LEMON, graphToEps()
-%%CreationDate: Fri Nov  4 13:47:12 2005
+%%CreationDate: Fri Mar  8 00:22:15 2013
 %%BoundingBox: 0 0 842 596
 %%EndComments
@@ -54,126 +54,126 @@
 %Edges:
 gsave
-2 setlinewidth 0 0 1 setrgbcolor newpath
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 218.178 27.2723 moveto
-192.373 -40.1551 188.622 -49.9556 169.228 -100.631 curveto stroke
-newpath 164.939 -111.838 moveto 165.492 -99.2013 lineto 172.964 -102.061 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+195.849 -31.0725 190.033 -46.2697 176.306 -82.1369 curveto stroke
+newpath 163.235 -116.291 moveto 165.206 -77.8889 lineto 187.405 -86.3849 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 44.8044 15.5841 moveto
-119.293 20.6059 129.775 21.3125 186.25 25.1199 curveto stroke
-newpath 198.223 25.927 moveto 186.519 21.1289 lineto 185.981 29.1108 lineto closepath fill
-2 setlinewidth 1 0 0 setrgbcolor newpath
+109.705 19.9594 126.016 21.0591 166.493 23.7879 curveto stroke
+newpath 202.98 26.2477 moveto 167.292 11.9299 lineto 165.694 35.6458 lineto closepath fill
+4.56973 setlinewidth 1 0 0 setrgbcolor newpath
 218.178 27.2723 moveto
-285.395 -87.4449 290.763 -96.6058 348.102 -194.464 curveto stroke
-newpath 354.169 -204.818 moveto 344.651 -196.487 lineto 351.554 -192.442 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+281.264 -80.3935 289.87 -95.0808 338.092 -177.379 curveto stroke
+newpath 356.579 -208.932 moveto 327.837 -183.388 lineto 348.346 -171.371 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 157.79 -130.517 moveto
-108.71 -67.0521 102.27 -58.7243 64.3804 -9.72954 curveto stroke
-newpath 57.0394 -0.236898 moveto 67.5446 -7.28254 lineto 61.2162 -12.1765 lineto closepath fill
-2 setlinewidth 1 0 0 setrgbcolor newpath
+114.446 -74.4692 104.358 -61.4239 76.4943 -25.394 curveto stroke
+newpath 54.1228 3.53455 moveto 85.8959 -18.1234 lineto 67.0928 -32.6646 lineto closepath fill
+4.56973 setlinewidth 1 0 0 setrgbcolor newpath
 -105.193 -261.035 moveto
--35.6576 -132.801 -30.5923 -123.459 29.5506 -12.5464 curveto stroke
-newpath 35.2708 -1.99743 moveto 33.0669 -14.4531 lineto 26.0343 -10.6397 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+-39.4801 -139.85 -31.344 -124.846 20.1113 -29.9539 curveto stroke
+newpath 37.5434 2.19358 moveto 30.559 -35.6192 lineto 9.66361 -24.2886 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 -465.576 -42.8564 moveto
--559.078 -25.5413 -569.47 -23.6169 -644.498 -9.72286 curveto stroke
-newpath -656.297 -7.5378 moveto -643.77 -5.78973 lineto -645.226 -13.656 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+-550.335 -27.1603 -566.8 -24.1113 -625.027 -13.3286 curveto stroke
+newpath -660.985 -6.66971 moveto -622.863 -1.64245 lineto -627.191 -25.0148 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 -574.666 -153.893 moveto
--528.842 -107.252 -521.515 -99.794 -488.002 -65.683 curveto stroke
-newpath -479.592 -57.123 moveto -485.149 -68.4863 lineto -490.856 -62.8797 lineto closepath fill
-2 setlinewidth 1 0 0 setrgbcolor newpath
+-535.911 -114.447 -524.692 -103.027 -501.88 -79.8085 curveto stroke
+newpath -476.251 -53.7222 moveto -493.402 -88.1377 lineto -510.358 -71.4793 lineto closepath fill
+4.56973 setlinewidth 1 0 0 setrgbcolor newpath
 -490.901 120.777 moveto
--480.122 51.1328 -478.519 40.7713 -470.47 -11.2329 curveto stroke
-newpath -468.635 -23.0917 moveto -474.423 -11.8447 lineto -466.517 -10.6212 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+-481.623 60.8277 -479.143 44.8049 -473.499 8.33636 curveto stroke
+newpath -467.906 -27.8032 moveto -485.244 6.51862 lineto -461.754 10.1541 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 -675.963 -3.89604 moveto
--632.116 -68.8235 -626.228 -77.5422 -592.575 -127.374 curveto stroke
-newpath -585.859 -137.319 moveto -595.89 -129.612 lineto -589.26 -125.135 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+-637.405 -60.9909 -628.201 -74.6206 -603.658 -110.963 curveto stroke
+newpath -583.191 -141.27 moveto -613.507 -117.615 lineto -593.808 -104.312 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 -490.901 120.777 moveto
--435.445 215.844 -430.107 224.995 -384.3 303.522 curveto stroke
-newpath -378.253 313.887 moveto -380.845 301.507 lineto -387.755 305.537 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+-439.75 208.465 -431.238 223.057 -394.278 286.417 curveto stroke
+newpath -375.851 318.006 moveto -384.012 280.429 lineto -404.543 292.406 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 -266.879 114.933 moveto
--367.067 117.547 -377.642 117.822 -458.912 119.943 curveto stroke
-newpath -470.908 120.255 moveto -458.807 123.941 lineto -459.016 115.944 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+-358.311 117.318 -375.109 117.756 -439.117 119.426 curveto stroke
+newpath -475.674 120.38 moveto -438.807 131.307 lineto -439.426 107.545 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 -368.176 331.163 moveto
--322.511 233.685 -318.018 224.095 -280.454 143.911 curveto stroke
-newpath -275.364 133.044 moveto -284.076 142.214 lineto -276.832 145.608 lineto closepath fill
-2 setlinewidth 1 0 0 setrgbcolor newpath
+-326.156 241.466 -318.997 226.186 -288.855 161.843 curveto stroke
+newpath -273.341 128.727 moveto -299.617 156.801 lineto -278.092 166.885 lineto closepath fill
+4.56973 setlinewidth 1 0 0 setrgbcolor newpath
 -266.879 114.933 moveto
--224.004 235.52 -220.448 245.52 -184.094 347.765 curveto stroke
-newpath -180.074 359.072 moveto -180.325 346.425 lineto -187.863 349.105 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+-226.764 227.755 -221.069 243.774 -190.728 329.107 curveto stroke
+newpath -178.477 363.564 moveto -179.53 325.126 lineto -201.926 333.089 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 -251.294 -335.059 moveto
--189.25 -303.624 -179.902 -298.887 -133.738 -275.498 curveto stroke
-newpath -123.034 -270.074 moveto -131.93 -279.066 lineto -135.546 -271.93 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+-198.044 -308.079 -183.61 -300.766 -151.402 -284.448 curveto stroke
+newpath -118.781 -267.92 moveto -146.031 -295.049 lineto -156.774 -273.846 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 -389.604 -136.361 moveto
--327.15 -226.083 -321.098 -234.777 -269.576 -308.795 curveto stroke
-newpath -262.72 -318.644 moveto -272.859 -311.081 lineto -266.293 -306.51 lineto closepath fill
-2 setlinewidth 1 0 0 setrgbcolor newpath
+-332.039 -219.059 -322.392 -232.919 -280.889 -292.543 curveto stroke
+newpath -259.996 -322.557 moveto -290.643 -299.333 lineto -271.134 -285.753 lineto closepath fill
+4.56973 setlinewidth 1 0 0 setrgbcolor newpath
 5.84406 175.322 moveto
--76.0754 267.926 -83.1051 275.873 -152.172 353.948 curveto stroke
-newpath -160.122 362.936 moveto -149.176 356.598 lineto -155.168 351.298 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+-70.5724 261.706 -81.8227 274.423 -139.051 339.116 curveto stroke
+newpath -163.281 366.507 moveto -130.149 346.991 lineto -147.953 331.242 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 169.478 311.683 moveto
-96.8003 251.119 88.6819 244.353 30.4273 195.808 curveto stroke
-newpath 21.2086 188.126 moveto 27.8666 198.881 lineto 32.988 192.735 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+103.641 256.819 90.7821 246.103 45.6398 208.485 curveto stroke
+newpath 17.546 185.074 moveto 38.0313 217.615 lineto 53.2483 199.355 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 342.851 111.037 moveto
-263.766 202.563 256.831 210.589 190.4 287.47 curveto stroke
-newpath 182.554 296.55 moveto 193.427 290.085 lineto 187.373 284.855 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+269.224 196.246 258.132 209.083 203.347 272.486 curveto stroke
+newpath 179.437 300.157 moveto 212.34 280.257 lineto 194.354 264.716 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 5.84406 175.322 moveto
-163.16 145.314 173.605 143.321 311.418 117.033 curveto stroke
-newpath 323.205 114.784 moveto 310.668 113.104 lineto 312.167 120.962 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+155.419 146.79 172.221 143.585 291.966 120.743 curveto stroke
+newpath 327.888 113.891 moveto 289.739 109.069 lineto 294.193 132.418 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 342.851 111.037 moveto
-497.255 2.58683 505.964 -3.53033 643.932 -100.436 curveto stroke
-newpath 653.752 -107.334 moveto 641.633 -103.71 lineto 646.231 -97.163 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+490.978 6.99574 505.015 -2.86383 627.727 -89.0547 curveto stroke
+newpath 657.653 -110.074 moveto 620.896 -98.7802 lineto 634.558 -79.3291 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 364.28 -222.074 moveto
-354.298 -66.9063 353.616 -56.2971 344.905 79.1029 curveto stroke
-newpath 344.135 91.0781 moveto 348.897 79.3597 lineto 340.914 78.8461 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+354.807 -74.8128 353.709 -57.7536 346.177 59.3416 curveto stroke
+newpath 343.829 95.836 moveto 358.037 60.1045 lineto 334.316 58.5786 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 670.118 -118.829 moveto
-528.037 -166.793 517.967 -170.192 394.599 -211.839 curveto stroke
-newpath 383.229 -215.677 moveto 393.32 -208.049 lineto 395.878 -215.629 lineto closepath fill
-2 setlinewidth 1 0 0 setrgbcolor newpath
+535.595 -164.241 519.412 -169.704 413.361 -205.505 curveto stroke
+newpath 378.712 -217.202 moveto 409.559 -194.245 lineto 417.162 -216.766 lineto closepath fill
+4.56973 setlinewidth 1 0 0 setrgbcolor newpath
 -105.193 -261.035 moveto
-118.401 -242.479 129.015 -241.598 332.39 -224.721 curveto stroke
-newpath 344.348 -223.728 moveto 332.72 -228.707 lineto 332.059 -220.734 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+110.939 -243.099 128.069 -241.677 312.655 -226.358 curveto stroke
+newpath 349.1 -223.334 moveto 313.638 -238.202 lineto 311.672 -214.514 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 -105.193 -261.035 moveto
--160.867 -161.176 -166.028 -151.918 -212.336 -68.858 curveto stroke
-newpath -218.179 -58.3769 moveto -208.842 -66.9102 lineto -215.829 -70.8058 lineto closepath fill
-2 setlinewidth 0 0 1 setrgbcolor newpath
+-156.746 -168.566 -164.987 -153.784 -202.693 -86.1539 curveto stroke
+newpath -220.5 -54.2129 moveto -192.312 -80.3665 lineto -213.073 -91.9413 lineto closepath fill
+4.56973 setlinewidth 0 0 1 setrgbcolor newpath
 -227.918 -40.9084 moveto
--298.35 -82.4884 -307.42 -87.8432 -362.048 -120.093 curveto stroke
-newpath -372.381 -126.193 moveto -364.081 -116.648 lineto -360.014 -123.537 lineto closepath fill
+-290.327 -77.7521 -304.558 -86.1532 -344.995 -110.026 curveto stroke
+newpath -376.487 -128.617 moveto -351.037 -99.7914 lineto -338.953 -120.26 lineto closepath fill
 grestore
 %Nodes:
 gsave
--389.604 -136.361 20 0 1 0 nc
--227.918 -40.9084 20 0 1 0 nc
--105.193 -261.035 20 0 1 0 nc
-364.28 -222.074 20 1 1 0 nc
-670.118 -118.829 20 1 1 0 nc
-342.851 111.037 20 1 1 0 nc
-5.84406 175.322 20 1 1 0 nc
-169.478 311.683 20 1 1 0 nc
--173.374 377.916 20 1 0 1 nc
--251.294 -335.059 20 0 1 0 nc
--266.879 114.933 20 0 0 0 nc
--368.176 331.163 20 0 0 0 nc
--490.901 120.777 20 0 0 0 nc
--574.666 -153.893 20 1 0 0 nc
--675.963 -3.89604 20 1 0 0 nc
--465.576 -42.8564 20 1 0 0 nc
-44.8044 15.5841 20 0 0 1 nc
-157.79 -130.517 20 0 0 1 nc
-218.178 27.2723 20 0 0 1 nc
+-389.604 -136.361 15.2324 0 1 0 nc
+-227.918 -40.9084 15.2324 0 1 0 nc
+-105.193 -261.035 15.2324 0 1 0 nc
+364.28 -222.074 15.2324 1 1 0 nc
+670.118 -118.829 15.2324 1 1 0 nc
+342.851 111.037 15.2324 1 1 0 nc
+5.84406 175.322 15.2324 1 1 0 nc
+169.478 311.683 15.2324 1 1 0 nc
+-173.374 377.916 15.2324 1 0 1 nc
+-251.294 -335.059 15.2324 0 1 0 nc
+-266.879 114.933 15.2324 0 0 0 nc
+-368.176 331.163 15.2324 0 0 0 nc
+-490.901 120.777 15.2324 0 0 0 nc
+-574.666 -153.893 15.2324 1 0 0 nc
+-675.963 -3.89604 15.2324 1 0 0 nc
+-465.576 -42.8564 15.2324 1 0 0 nc
+44.8044 15.5841 15.2324 0 0 1 nc
+157.79 -130.517 15.2324 0 0 1 nc
+218.178 27.2723 15.2324 0 0 1 nc
 grestore
 grestore