Index: src/lemon/dfs.h
===================================================================
--- src/lemon/dfs.h	(revision 1218)
+++ src/lemon/dfs.h	(revision 1220)
@@ -432,4 +432,38 @@
     }
 
+    ///Sets the map indicating if a node is reached.
+
+    ///Sets the map indicating if a node is reached.
+    ///If you don't use this function before calling \ref run(),
+    ///it will allocate one. The destuctor deallocates this
+    ///automatically allocated map, of course.
+    ///\return <tt> (*this) </tt>
+    Dfs &reachedMap(ReachedMap &m) 
+    {
+      if(local_reached) {
+	delete _reached;
+	local_reached=false;
+      }
+      _reached = &m;
+      return *this;
+    }
+
+    ///Sets the map indicating if a node is processed.
+
+    ///Sets the map indicating if a node is processed.
+    ///If you don't use this function before calling \ref run(),
+    ///it will allocate one. The destuctor deallocates this
+    ///automatically allocated map, of course.
+    ///\return <tt> (*this) </tt>
+    Dfs &processedMap(ProcessedMap &m) 
+    {
+      if(local_processed) {
+	delete _processed;
+	local_processed=false;
+      }
+      _processed = &m;
+      return *this;
+    }
+
   public:
     ///\name Execution control
Index: src/lemon/dijkstra.h
===================================================================
--- src/lemon/dijkstra.h	(revision 1218)
+++ src/lemon/dijkstra.h	(revision 1220)
@@ -808,4 +808,5 @@
   /// The \ref DijkstraWizardBase is a class to be the default traits of the
   /// \ref DijkstraWizard class.
+  /// \todo More named parameters are required...
   template<class GR,class LM>
   class DijkstraWizardBase : public DijkstraWizardDefaultTraits<GR,LM>
Index: src/test/bfs_test.cc
===================================================================
--- src/test/bfs_test.cc	(revision 1218)
+++ src/test/bfs_test.cc	(revision 1220)
@@ -59,4 +59,26 @@
 }
 
+void check_Bfs_Function_Compile() 
+{
+  typedef int VType;
+  typedef concept::StaticGraph Graph;
+
+  typedef Graph::Edge Edge;
+  typedef Graph::Node Node;
+  typedef Graph::EdgeIt EdgeIt;
+  typedef Graph::NodeIt NodeIt;
+  typedef concept::ReadMap<Edge,VType> LengthMap;
+   
+  bfs(Graph(),Node()).run();
+  bfs(Graph()).source(Node()).run();
+  bfs(Graph())
+    .predMap(concept::WriteMap<Node,Edge>())
+    .distMap(concept::WriteMap<Node,VType>())
+    .reachedMap(concept::ReadWriteMap<Node,bool>())
+    .processedMap(concept::WriteMap<Node,bool>())
+    .run(Node());
+  
+}
+
 int main()
 {
Index: src/test/dfs_test.cc
===================================================================
--- src/test/dfs_test.cc	(revision 1218)
+++ src/test/dfs_test.cc	(revision 1220)
@@ -59,4 +59,27 @@
 }
 
+
+void check_Dfs_Function_Compile() 
+{
+  typedef int VType;
+  typedef concept::StaticGraph Graph;
+
+  typedef Graph::Edge Edge;
+  typedef Graph::Node Node;
+  typedef Graph::EdgeIt EdgeIt;
+  typedef Graph::NodeIt NodeIt;
+  typedef concept::ReadMap<Edge,VType> LengthMap;
+   
+  dfs(Graph(),Node()).run();
+  dfs(Graph()).source(Node()).run();
+  dfs(Graph())
+    .predMap(concept::WriteMap<Node,Edge>())
+    .distMap(concept::WriteMap<Node,VType>())
+    .reachedMap(concept::ReadWriteMap<Node,bool>())
+    .processedMap(concept::WriteMap<Node,bool>())
+    .run(Node());
+  
+}
+
 int main()
 {
Index: src/test/dijkstra_test.cc
===================================================================
--- src/test/dijkstra_test.cc	(revision 1218)
+++ src/test/dijkstra_test.cc	(revision 1220)
@@ -63,4 +63,25 @@
 }
 
+void check_Dijkstra_Function_Compile() 
+{
+  typedef int VType;
+  typedef concept::StaticGraph Graph;
+
+  typedef Graph::Edge Edge;
+  typedef Graph::Node Node;
+  typedef Graph::EdgeIt EdgeIt;
+  typedef Graph::NodeIt NodeIt;
+  typedef concept::ReadMap<Edge,VType> LengthMap;
+   
+  dijkstra(Graph(),LengthMap(),Node()).run();
+  dijkstra(Graph(),LengthMap()).source(Node()).run();
+  dijkstra(Graph(),LengthMap())
+    .predMap(concept::WriteMap<Node,Edge>())
+    .distMap(concept::WriteMap<Node,VType>())
+    .run(Node());
+  
+}
+
+
 int main()
 {