Index: NEWS
===================================================================
--- NEWS	(revision 1273)
+++ NEWS	(revision 1275)
@@ -1,8 +1,8 @@
-2013-08-10 Version 1.1.6 released
-
-        Release series 1.1 has reached its end of life. This is the last
-        bugfix release in that series.
-
-        #432: Add missing doc/template.h to release tarball
+2013-08-10 Version 1.2.4 released
+
+        Bugfix release.
+
+        #432: Add missing doc/template.h and doc/references.bib to release
+              tarball
         #433: Support shared library build
         ----: Update CPLEX lookup
@@ -17,12 +17,9 @@
         #453: Avoid GCC 4.7 compiler warnings
         #445: Fix missing initialization in CplexEnv::CplexEnv()
-        #470: Suppress 'unused local typedefs' warnings, and resolve others
         #461: Bugfix in assert.h
-        #294: Add explicit namespace to ignore_unused_variable_warning() usages
-        #439: Fix biNodeConnected() function
-        #439: Clarification in biNodeConnected() doc
-        ----: Remove -Werror form AM_INIT_AUTOMAKE
-
-2011-11-09 Version 1.1.5 released
+        #470: Fix compilation issues related to various gcc versions
+        #439: Bugfix in biNodeConnected()
+
+2011-11-09 Version 1.2.3 released
 
         Bugfix release.
@@ -32,5 +29,5 @@
         #430: Fix LpBase::Constr two-side limit bug
 
-2011-08-08 Version 1.1.4 released
+2011-08-08 Version 1.2.2 released
 
         Bugfix release.
@@ -46,6 +43,7 @@
               - Do not look for COIN_VOL libraries
         #382: Allow lgf file without Arc maps
-        
-2010-10-21 Version 1.1.3 released
+        #417: Bug fix in CostScaling
+
+2010-10-21 Version 1.2.1 released
 
         Bugfix release.
@@ -55,43 +53,87 @@
               The target graph is cleared before adding nodes and arcs/edges.
 
-        #356: Fix multiple execution bug in weighted matchings
         #364: Add missing UndirectedTags
         #368: Fix the usage of std::numeric_limits<>::min() in Network Simplex
         #372: Fix a critical bug in preflow
 
-2010-03-08 Version 1.1.2 released
-
-        Bugfix release.
-
-        #317: Fix (and improve) error message in mip_test.cc
-              Remove unnecessary OsiCbc dependency
-        #250: Fix in pathSource() and pathTarget()
-        #322: Distribute LEMONConfig.cmake.in
-        #321: Use pathCopy(from,to) instead of copyPath(to,from)
-        #330: Bug fix in map_extender.h
-        #335: Fix clear() function in ExtendFindEnum
-        #337: Use void* as LPX object pointer
-        #336: Fix the date field comment of graphToEps() output
-        #323: Bug fix in Suurballe
-
-2009-10-03 Version 1.1.1 released
-
-        Bugfix release.
-
-        #295: Suppress MSVC warnings using pragmas
-        ----: Various CMAKE related improvements
-              * Remove duplications from doc/CMakeLists.txt
-              * Rename documentation install folder from 'docs' to 'html'
-              * Add tools/CMakeLists.txt to the tarball
-              * Generate and install LEMONConfig.cmake
-              * Change the label of the html project in Visual Studio
-              * Fix the check for the 'long long' type
-              * Put the version string into config.h
-              * Minor CMake improvements
-              * Set the version to 'hg-tip' if everything fails
-        #311: Add missing 'explicit' keywords
-        #302: Fix the implementation and doc of CrossRefMap
-        #308: Remove duplicate list_graph.h entry from source list
-        #307: Bug fix in Preflow and Circulation
+2010-03-19 Version 1.2 released
+
+        This is major feature release
+
+        * New algorithms
+          * Bellman-Ford algorithm (#51)
+          * Minimum mean cycle algorithms (#179)
+            * Karp, Hartman-Orlin and Howard algorithms
+          * New minimum cost flow algorithms (#180)
+            * Cost Scaling algorithms
+            * Capacity Scaling algorithm
+            * Cycle-Canceling algorithms
+          * Planarity related algorithms (#62)
+            * Planarity checking algorithm
+            * Planar embedding algorithm
+            * Schnyder's planar drawing algorithm
+            * Coloring planar graphs with five or six colors
+          * Fractional matching algorithms (#314)
+        * New data structures
+          * StaticDigraph structure (#68)
+          * Several new priority queue structures (#50, #301)
+            * Fibonacci, Radix, Bucket, Pairing, Binomial
+              D-ary and fourary heaps (#301)
+          * Iterable map structures (#73)
+        * Other new tools and functionality
+          * Map utility functions (#320)
+          * Reserve functions are added to ListGraph and SmartGraph (#311)
+          * A resize() function is added to HypercubeGraph (#311)
+          * A count() function is added to CrossRefMap (#302)
+          * Support for multiple targets in Suurballe using fullInit() (#181)
+          * Traits class and named parameters for Suurballe (#323)
+          * Separate reset() and resetParams() functions in NetworkSimplex
+            to handle graph changes (#327)
+          * tolerance() functions are added to HaoOrlin (#306)
+        * Implementation improvements
+          * Improvements in weighted matching algorithms (#314)
+            * Jumpstart initialization
+          * ArcIt iteration is based on out-arc lists instead of in-arc lists
+            in ListDigraph (#311)
+          * Faster add row operation in CbcMip (#203)
+          * Better implementation for split() in ListDigraph (#311)
+          * ArgParser can also throw exception instead of exit(1) (#332)
+        * Miscellaneous
+          * A simple interactive bootstrap script
+          * Doc improvements (#62,#180,#299,#302,#303,#304,#307,#311,#331,#315,
+                #316,#319)
+            * BibTeX references in the doc (#184)
+          * Optionally use valgrind when running tests
+          * Also check ReferenceMapTag in concept checks (#312)
+          * dimacs-solver uses long long type by default.
+        * Several bugfixes (compared to release 1.1):
+          #295: Suppress MSVC warnings using pragmas
+          ----: Various CMAKE related improvements
+                * Remove duplications from doc/CMakeLists.txt
+                * Rename documentation install folder from 'docs' to 'html'
+                * Add tools/CMakeLists.txt to the tarball
+                * Generate and install LEMONConfig.cmake
+                * Change the label of the html project in Visual Studio
+                * Fix the check for the 'long long' type
+                * Put the version string into config.h
+                * Minor CMake improvements
+                * Set the version to 'hg-tip' if everything fails
+          #311: Add missing 'explicit' keywords
+          #302: Fix the implementation and doc of CrossRefMap
+          #308: Remove duplicate list_graph.h entry from source list
+          #307: Bugfix in Preflow and Circulation
+          #305: Bugfix and extension in the rename script
+          #312: Also check ReferenceMapTag in concept checks
+          #250: Bugfix in pathSource() and pathTarget()
+          #321: Use pathCopy(from,to) instead of copyPath(to,from)
+          #322: Distribure LEMONConfig.cmake.in
+          #330: Bug fix in map_extender.h
+          #336: Fix the date field comment of graphToEps() output
+          #323: Bug fix in Suurballe
+          #335: Fix clear() function in ExtendFindEnum
+          #337: Use void* as the LPX object pointer
+          #317: Fix (and improve) error message in mip_test.cc
+                Remove unnecessary OsiCbc dependency
+          #356: Allow multiple executions of weighted matching algorithms (#356)
 
 2009-05-13 Version 1.1 released
@@ -169,5 +211,5 @@
           ----: Add missing unistd.h include to time_measure.h
           #204: Compilation bug fixed in graph_to_eps.h with VS2005
-          #214,#215: windows.h should never be included by lemon headers
+          #214,#215: windows.h should never be included by LEMON headers
           #230: Build systems check the availability of 'long long' type
           #229: Default implementation of Tolerance<> is used for integer types