Index: src/work/athos/lp/lp_base.h
===================================================================
--- src/work/athos/lp/lp_base.h	(revision 1291)
+++ src/work/athos/lp/lp_base.h	(revision 1293)
@@ -106,13 +106,9 @@
 
     ///\e
-    enum SolutionXXXType {
-      ///\e
-      INFEASIBLE = 0,
-      ///\e
-      UNBOUNDED = 1,
-      ///\e
-      OPTIMAL = 2,
-      ///\e
-      FEASIBLE = 3
+    enum SolutionStatus {
+      ///\e
+      SOLVED = 0,
+      ///\e
+      UNSOLVED = 1
     };
       
@@ -120,11 +116,11 @@
     enum SolutionType {
       ///\e
-      INFEASIBLE = 0,
-      ///\e
-      UNDEFINED = 1,
-      ///\e
-      OPTIMAL = 2,
-      ///\e
-      FEASIBLE = 3
+      UNDEFINED = 0,
+      ///\e
+      INFEASIBLE = 1,
+      ///\e
+      FEASIBLE = 2,
+      ///\e
+      OPTIMAL = 3
     };
       
@@ -419,5 +415,5 @@
     ///\bug Wrong interface
     ///
-    virtual SolutionXXXType _solve() = 0;
+    virtual SolutionStatus _solve() = 0;
 
     ///\e
@@ -425,5 +421,5 @@
     ///\bug Wrong interface
     ///
-    virtual Value _getSolution(int i) = 0;
+    virtual Value _getPrimal(int i) = 0;
     ///\e
 
@@ -576,36 +572,58 @@
     /// Set the lower bound of a column (i.e a variable)
 
-    /// The upper bound of a variable (column) have to be given by an 
+    /// The upper bound of a variable (column) has to be given by an 
     /// extended number of type Value, i.e. a finite number of type 
     /// Value or -\ref INF.
-    void setColLowerBound(Col c, Value value) {
+    void colLowerBound(Col c, Value value) {
       _setColLowerBound(cols.floatingId(c.id),value);
     }
     /// Set the upper bound of a column (i.e a variable)
 
-    /// The upper bound of a variable (column) have to be given by an 
+    /// The upper bound of a variable (column) has to be given by an 
     /// extended number of type Value, i.e. a finite number of type 
     /// Value or \ref INF.
-    void setColUpperBound(Col c, Value value) {
+    void colUpperBound(Col c, Value value) {
       _setColUpperBound(cols.floatingId(c.id),value);
     };
+    /// Set the lower and the upper bounds of a column (i.e a variable)
+
+    /// The lower and the upper bounds of
+    /// a variable (column) have to be given by an 
+    /// extended number of type Value, i.e. a finite number of type 
+    /// Value, -\ref INF or \ref INF.
+    void colBounds(Col c, Value lower, Value upper) {
+      _setColLowerBound(cols.floatingId(c.id),lower);
+      _setColUpperBound(cols.floatingId(c.id),upper);
+    }
+    
     /// Set the lower bound of a row (i.e a constraint)
 
-    /// The lower bound of a linear expression (row) have to be given by an 
+    /// The lower bound of a linear expression (row) has to be given by an 
     /// extended number of type Value, i.e. a finite number of type 
     /// Value or -\ref INF.
-    void setRowLowerBound(Row r, Value value) {
+    void rowLowerBound(Row r, Value value) {
       _setRowLowerBound(rows.floatingId(r.id),value);
     };
     /// Set the upper bound of a row (i.e a constraint)
 
-    /// The upper bound of a linear expression (row) have to be given by an 
+    /// The upper bound of a linear expression (row) has to be given by an 
     /// extended number of type Value, i.e. a finite number of type 
     /// Value or \ref INF.
-    void setRowUpperBound(Row r, Value value) {
+    void rowUpperBound(Row r, Value value) {
       _setRowUpperBound(rows.floatingId(r.id),value);
     };
+    /// Set the lower and the upper bounds of a row (i.e a variable)
+
+    /// The lower and the upper bounds of
+    /// a constraint (row) have to be given by an 
+    /// extended number of type Value, i.e. a finite number of type 
+    /// Value, -\ref INF or \ref INF.
+    void rowBounds(Row c, Value lower, Value upper) {
+      _setRowLowerBound(rows.floatingId(c.id),lower);
+      _setRowUpperBound(rows.floatingId(c.id),upper);
+    }
+    
     ///Set an element of the objective function
-    void setObjCoeff(Col c, Value v) {_setObjCoeff(cols.floatingId(c.id),v); };
+    void objCoeff(Col c, Value v) {_setObjCoeff(cols.floatingId(c.id),v); };
     ///Set the objective function
     
@@ -615,5 +633,5 @@
       clearObj();
       for (Expr::iterator i=e.begin(); i!=e.end(); ++i)
-	setObjCoeff((*i).first,(*i).second);
+	objCoeff((*i).first,(*i).second);
     }
 
@@ -626,5 +644,5 @@
 
     ///\e
-    SolutionType solve() { return _solve(); }
+    SolutionStatus solve() { return _solve(); }
     
     ///@}
@@ -635,5 +653,5 @@
 
     ///\e
-    Value solution(Col c) { return _getSolution(cols.floatingId(c.id)); }
+    Value primal(Col c) { return _getPrimal(cols.floatingId(c.id)); }
 
     ///@}