Index: CMakeLists.txt
===================================================================
--- CMakeLists.txt	(revision 1125)
+++ CMakeLists.txt	(revision 1053)
@@ -67,5 +67,5 @@
     # C4996: 'function': was declared deprecated
   ELSE()
-    SET(CXX_WARNING "-Wall")
+    SET(CXX_WARNING "-Wall -W")
   ENDIF()
 ENDIF()
@@ -74,8 +74,8 @@
 SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${LEMON_CXX_WARNING_FLAGS}")
 
-SET( CMAKE_CXX_FLAGS_MAINTAINER "-Werror -ggdb -O0" CACHE STRING
+SET( CMAKE_CXX_FLAGS_MAINTAINER "-Werror -ggdb" CACHE STRING
     "Flags used by the C++ compiler during maintainer builds."
     FORCE )
-SET( CMAKE_C_FLAGS_MAINTAINER "-Werror -O0" CACHE STRING
+SET( CMAKE_C_FLAGS_MAINTAINER "-Werror" CACHE STRING
     "Flags used by the C compiler during maintainer builds."
     FORCE )
Index: lemon/bfs.h
===================================================================
--- lemon/bfs.h	(revision 1125)
+++ lemon/bfs.h	(revision 525)
@@ -1248,5 +1248,4 @@
       }
       _Visitor& visitor;
-      Constraints() {}
     };
   };
Index: lemon/concepts/graph_components.h
===================================================================
--- lemon/concepts/graph_components.h	(revision 1126)
+++ lemon/concepts/graph_components.h	(revision 1081)
@@ -116,5 +116,4 @@
         const _GraphItem &ia;
         const _GraphItem &ib;
-        Constraints() {}
       };
     };
@@ -176,5 +175,4 @@
 
         const _Digraph& digraph;
-        Constraints() {}
       };
     };
@@ -293,5 +291,4 @@
 
         const _Graph& graph;
-      Constraints() {}
       };
 
@@ -373,5 +370,4 @@
 
         const _Digraph& digraph;
-        Constraints() {}
       };
     };
@@ -426,5 +422,4 @@
 
         const _Graph& graph;
-        Constraints() {}
       };
     };
@@ -504,5 +499,4 @@
         }
         const GR& g;
-        Constraints() {}
       };
     };
@@ -593,5 +587,4 @@
         const Base& node;
         const GR& graph;
-        Constraints() {}
       };
     };
@@ -770,5 +763,4 @@
 
         const _Digraph& digraph;
-        Constraints() {}
       };
     };
@@ -895,5 +887,4 @@
 
         const _Graph& graph;
-        Constraints() {}
       };
     };
@@ -953,5 +944,4 @@
 
         const _Digraph& digraph;
-        Constraints() {}
       };
     };
@@ -995,5 +985,4 @@
 
         const _Graph& graph;
-        Constraints() {}
       };
     };
@@ -1073,5 +1062,4 @@
         const GR &g;
         const typename GraphMap::Value &t;
-        Constraints() {}
       };
 
@@ -1212,5 +1200,4 @@
 
         const _Digraph& digraph;
-        Constraints() {}
       };
     };
@@ -1298,5 +1285,4 @@
 
         const _Graph& graph;
-        Constraints() {}
       };
     };
@@ -1343,5 +1329,4 @@
 
         _Digraph& digraph;
-        Constraints() {}
       };
     };
@@ -1388,5 +1373,4 @@
 
         _Graph& graph;
-        Constraints() {}
       };
     };
@@ -1428,5 +1412,4 @@
 
         _Digraph& digraph;
-        Constraints() {}
       };
     };
@@ -1468,5 +1451,4 @@
 
         _Graph& graph;
-        Constraints() {}
       };
     };
@@ -1497,5 +1479,4 @@
 
         _Digraph& digraph;
-        Constraints() {}
       };
     };
@@ -1526,5 +1507,4 @@
 
         _Graph& graph;
-        Constraints() {}
       };
     };
Index: lemon/concepts/heap.h
===================================================================
--- lemon/concepts/heap.h	(revision 1125)
+++ lemon/concepts/heap.h	(revision 631)
@@ -253,5 +253,4 @@
         _Heap& heap;
         ItemIntMap& map;
-        Constraints() {}
       };
     };
Index: lemon/concepts/maps.h
===================================================================
--- lemon/concepts/maps.h	(revision 1126)
+++ lemon/concepts/maps.h	(revision 1081)
@@ -69,5 +69,4 @@
         const typename _ReadMap::Key& own_key;
         const _ReadMap& m;
-        Constraints() {}
       };
 
@@ -111,5 +110,4 @@
         const typename _WriteMap::Value& own_val;
         _WriteMap& m;
-        Constraints() {}
       };
     };
@@ -132,6 +130,5 @@
       /// Returns the value associated with the given key.
       Value operator[](const Key &) const {
-        Value *r = 0;
-        return *r;
+        return *static_cast<Value *>(0);
       }
 
@@ -173,12 +170,10 @@
       /// Returns a reference to the value associated with the given key.
       Reference operator[](const Key &) {
-        Value *r = 0;
-        return *r;
+        return *static_cast<Value *>(0);
       }
 
       /// Returns a const reference to the value associated with the given key.
       ConstReference operator[](const Key &) const {
-        Value *r = 0;
-        return *r;
+        return *static_cast<Value *>(0);
       }
 
@@ -211,5 +206,4 @@
         typename _ReferenceMap::ConstReference own_cref;
         _ReferenceMap& m;
-        Constraints() {}
       };
     };
Index: lemon/concepts/path.h
===================================================================
--- lemon/concepts/path.h	(revision 1125)
+++ lemon/concepts/path.h	(revision 606)
@@ -160,5 +160,4 @@
         }
         _Path& p;
-        PathDumperConstraints() {}
       };
 
@@ -186,5 +185,4 @@
         }
         _Path& p;
-        PathDumperConstraints() {}
       };
 
Index: lemon/dfs.h
===================================================================
--- lemon/dfs.h	(revision 1126)
+++ lemon/dfs.h	(revision 1081)
@@ -1192,5 +1192,4 @@
       }
       _Visitor& visitor;
-      Constraints() {}
     };
   };